## httraqt 1.4.11

=== CMakeLists.txt ===
PROJECT(httraqt)

# Configure CMake ...
CMAKE_MINIMUM_REQUIRED(VERSION 2.8 FATAL_ERROR)
#CMAKE_POLICY(SET CMP0003 OLD)
#CMAKE_POLICY(SET CMP0015 OLD)

# Qt versions to set: 4, 5, 6
SET(USE_QT_VERSION 6)

MESSAGE(STATUS "Using of Qt version for compiling: ${USE_QT_VERSION}")


OPTION (USE_DEBUGGER "Include in binary file debug information" OFF)
# SET(USE_DEBUGGER false)

#enable or disable profiling info
# SET(USE_PROFILER false)

OPTION (USE_PROFILER "Include in binary file profiling information" OFF)



IF(USE_DEBUGGER)
  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${CMAKE_CXX_FLAGS_DEBUG} -Wall")
ELSE()
  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${CMAKE_CXX_FLAGS_RELEASE} -Wall")
ENDIF()

SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DQT_NO_DEPRECATED_WARNINGS")

# INCLUDE(CPack)
INCLUDE(CheckIncludeFile)
INCLUDE(CheckIncludeFileCXX)
INCLUDE(TestCXXAcceptsFlag)
INCLUDE(CheckCXXCompilerFlag)
INCLUDE(FindPkgConfig)

# SET(TARGET_NAME httraqt )

SET(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

SET(CURRENT_BUILD_DIR ${CMAKE_CURRENT_BINARY_DIR})

INCLUDE(OutOfSourceBuild) # Disallow in-source builds
INCLUDE(GenerateDEF) # Convenience macro for linking Win32 DLLs using MSVC
INCLUDE(Dependencies)
# INCLUDE(HTTRAQTWordSize) # Detect 32/64 bit platform
# INCLUDE(HTTRAQTCompiler) # Detect problematic compilers

# Set the HTTraQt version
#cat README | grep -E  '^[0-9]+\.[0-9]+\.[0-9]+' | head -n 1
EXECUTE_PROCESS (
   COMMAND cat README
   COMMAND grep -E  "^[0-9]+\\.[0-9]+\\.[0-9]+"
   COMMAND head -n 1
   WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}
   RESULT_VARIABLE HTTQTVERSION
   OUTPUT_VARIABLE DESCRIBE_STRING
   OUTPUT_STRIP_TRAILING_WHITESPACE)



IF(NOT DESCRIBE_STRING)
        SET(DESCRIBE_STRING "no valid git tag for ${PROJECT_NAME} found")
ELSE()
        STRING(REGEX MATCH "([0-9]+\\.[0-9]+\\.[0-9]+)" HTTRAQT_VERSION "${DESCRIBE_STRING}" )
        IF (NOT HTTRAQT_VERSION)
                SET(DESCRIBE_STRING "no valid git tag ${PROJECT_NAME}-x.x.x found")
        ENDIF()
ENDIF()


SET(APP_RESOURCES  "${PROJECT_SOURCE_DIR}/sources/httraqt.qrc")


MESSAGE("-- Version info: ${HTTRAQT_VERSION}") 
SET(VERSION ${HTTRAQT_VERSION})

EXECUTE_PROCESS (
      COMMAND date +"%d %b %Y"
      COMMAND sed -e "s/\"//g"
      OUTPUT_VARIABLE BUILD_DATE
      OUTPUT_STRIP_TRAILING_WHITESPACE)

MESSAGE("-- Version build date: ${BUILD_DATE}")

configure_file (
  "${PROJECT_SOURCE_DIR}/sources/version.h.in"
  "${PROJECT_SOURCE_DIR}/sources/version.h" )

# 
SET(HTTRAQT_PACKAGE httraqt)
# SET(HTTRAQT_VERSION ${HTTRAQT_MAJOR_VERSION}.${HTTRAQT_MINOR_VERSION}.${HTTRAQT_RELEASE_VERSION}.${HTTRAQT_BUILD_VERSION})
SET(HTTRAQT_HOST ${CMAKE_SYSTEM} ${CMAKE_SYSTEM_PROCESSOR})
SET(HTTRAQT_COPYRIGHT "Copyright (c) 2012-2023, Eduard Kalinowski. All Rights Reserved.")
SET(HTTRAQT_INSTALL_PREFIX ${CMAKE_INSTALL_PREFIX})

IF(${USE_QT_VERSION} MATCHES "4" OR ${USE_QT_VERSION} MATCHES "5")
    SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11 -fno-exceptions -fno-rtti")
ENDIF()

IF(${USE_QT_VERSION} MATCHES "6")
    SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++17 -fno-exceptions -fno-rtti")
ENDIF()

# options for gprof 
IF(USE_PROFILER)
  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pg")
  SET(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -pg")
  SET(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -pg")
  # after execution of program: gprof ./build/ponyprog
  # and get the information from gprof.txt file
  MESSAGE(STATUS "Compile with profiling information")
ELSE()
  MESSAGE(STATUS "Compile without profiling information")
ENDIF()

MESSAGE(STATUS "CMAKE_CXX_FLAGS: ${CMAKE_CXX_FLAGS}")

# Setup high-level build options
IF(WIN32 AND MSVC)
    SET(HTTRAQT_ENABLE_SYMBOL_VISIBILITY_DEFAULT ON)
ELSE()
    SET(HTTRAQT_ENABLE_SYMBOL_VISIBILITY_DEFAULT OFF)
ENDIF()


IF(${USE_QT_VERSION} MATCHES "4")
    FIND_PACKAGE(Qt4 REQUIRED)

    INCLUDE(FindQt4)
    IF(NOT QT4_FOUND)
        MESSAGE(FATAL_ERROR "Qt4 could not be found. "
        "If it's INSTALLed in a non-standard location, specify the path to qmake in QT_QMAKE_EXECUTABLE. "
        "You can do it in interactive mode (ccmake instead of cmake) or using -DVAR=VAL syntax.")
    ENDIF()
ENDIF()

IF(${USE_QT_VERSION} MATCHES "5")
    FIND_PACKAGE (Qt5 REQUIRED COMPONENTS Widgets)
    FIND_PACKAGE (Qt5 REQUIRED COMPONENTS Multimedia)
    FIND_PACKAGE (Qt5 REQUIRED COMPONENTS DBus)

    IF(NOT Qt5Widgets_FOUND)
        MESSAGE(FATAL_ERROR "Qt5 could not be found. "
        "If it's INSTALLed in a non-standard location, specify the path to qmake in QT_QMAKE_EXECUTABLE. "
        "You can do it in interactive mode (ccmake instead of cmake) or using -DVAR=VAL syntax.")
    ENDIF()
ENDIF()

IF(${USE_QT_VERSION} MATCHES "6")
    FIND_PACKAGE (Qt6 REQUIRED COMPONENTS Widgets)
    FIND_PACKAGE (Qt6 REQUIRED COMPONENTS Multimedia)
    FIND_PACKAGE (Qt6 REQUIRED COMPONENTS DBus)

    IF(NOT Qt6Widgets_FOUND)
        MESSAGE(FATAL_ERROR "Qt6 could not be found. "
        "If it's INSTALLed in a non-standard location, specify the path to qmake in QT_QMAKE_EXECUTABLE. "
        "You can do it in interactive mode (ccmake instead of cmake) or using -DVAR=VAL syntax.")
    ENDIF()
ENDIF()

INCLUDE(FindHttrack)

SET( HTTRACK_INCLUDES_DIR "" )

SET(HTTRAQT_CPACK_PACKAGE_SHLIBDEPS ON)

IF(${USE_QT_VERSION} MATCHES "4")
    INCLUDE_DIRECTORIES(${QT_INCLUDES})
    MESSAGE(STATUS "QT_INCLUDES ${QT_INCLUDES}")
#     LINK_DIRECTORIES(${QT_LIBRARY_DIR})
    MESSAGE(STATUS "QT_LIBRARY_DIR ${QT_LIBRARY_DIR}")
ENDIF()

IF(${USE_QT_VERSION} MATCHES "5")
    INCLUDE_DIRECTORIES(${Qt5Widgets_INCLUDE_DIRS}, ${Qt5Multimedia_INCLUDE_DIRS}, ${Qt5DBus_INCLUDE_DIRS})
    MESSAGE(STATUS "QT_INCLUDES  ${Qt5Widgets_INCLUDE_DIRS}, ${Qt5Multimedia_INCLUDE_DIRS}, ${Qt5DBus_INCLUDE_DIRS}")
ENDIF()

IF(${USE_QT_VERSION} MATCHES "6")
    INCLUDE_DIRECTORIES(${Qt6Widgets_INCLUDE_DIRS}, ${Qt6Multimedia_INCLUDE_DIRS}, ${Qt6DBus_INCLUDE_DIRS})
    MESSAGE(STATUS "QT_INCLUDES  ${Qt6Widgets_INCLUDE_DIRS}, ${Qt6Multimedia_INCLUDE_DIRS}, ${Qt6DBus_INCLUDE_DIRS}")
ENDIF()

SET ( OBJECTS_DIR temp )
SET ( MOC_DIR temp )
SET ( UI_HEADERS_DIR temp )
SET ( UI_SOURCES_DIR temp )

SET ( QT_USE_QTDBUS 1 )
  
ADD_SUBDIRECTORY(sources/main)
ADD_SUBDIRECTORY(sources/options)
#ADD_SUBDIRECTORY(sources/icons)


INCLUDE_DIRECTORIES( ${HTTRACK_INCLUDES_DIR}  ${CMAKE_SOURCE_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/sources/options/includes ${CMAKE_CURRENT_SOURCE_DIR}/sources/main/includes )

IF(${USE_QT_VERSION} MATCHES "4")
    #QT4_WRAP_CPP(APP_HEADERS_MOC ${HTTRACK_HEADERS} ${MAIN_HEADERS} ${OPT_HEADERS} )
    QT4_WRAP_CPP(APP_HEADERS_MOC ${MAIN_HEADERS} ${OPT_HEADERS} )
    QT4_WRAP_UI(APP_FORMS_HEADERS ${MAIN_FORMS} ${OPT_FORMS})
    QT4_ADD_RESOURCES(APP_RESOURCES_RCC ${APP_RESOURCES})
ENDIF()

IF(${USE_QT_VERSION} MATCHES "5")
    #QT5_WRAP_CPP(APP_HEADERS_MOC ${HTTRACK_HEADERS} ${MAIN_HEADERS} ${OPT_HEADERS} )
    QT5_WRAP_CPP(APP_HEADERS_MOC ${MAIN_HEADERS} ${OPT_HEADERS} )
    QT5_WRAP_UI(APP_FORMS_HEADERS ${MAIN_FORMS} ${OPT_FORMS})
    QT5_ADD_RESOURCES(APP_RESOURCES_RCC ${APP_RESOURCES})
ENDIF()

IF(${USE_QT_VERSION} MATCHES "6")
    #QT5_WRAP_CPP(APP_HEADERS_MOC ${HTTRACK_HEADERS} ${MAIN_HEADERS} ${OPT_HEADERS} )
    QT6_WRAP_CPP(APP_HEADERS_MOC ${MAIN_HEADERS} ${OPT_HEADERS} )
    QT6_WRAP_UI(APP_FORMS_HEADERS ${MAIN_FORMS} ${OPT_FORMS})
    QT6_ADD_RESOURCES(APP_RESOURCES_RCC ${APP_RESOURCES})
ENDIF()

INCLUDE_DIRECTORIES( ${HTTRACK_INCLUDES_DIR} ${CMAKE_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR})

SOURCE_GROUP( "Generated Files" FILES
    ${MOC_FILES_CPP}
    ${APP_FORMS_HEADERS}
    ${APP_RESOURCES_RCC}
)

IF(NOT ${USE_DEBUGGER})
    ADD_DEFINITIONS(${QT_DEFINITIONS} -DQT_NO_DEBUG_OUTPUT -DQT_USE_FAST_CONCATENATION -DQT_USE_FAST_OPERATOR_PLUS)
    #ADD_DEFINITIONS(${QT_DEFINITIONS} -DQT_NO_DEBUG_OUTPUT)
ENDIF()

IF(${USE_QT_VERSION} MATCHES "4")
    INCLUDE(${QT_USE_FILE})
    ADD_DEFINITIONS(${QT_DEFINITIONS} -DQT_PROJECT -DNO_QT3SUPPORT -DDISABLE_QT3SUPPORT)
ENDIF()

IF(${USE_QT_VERSION} MATCHES "5")
    ADD_DEFINITIONS( ${Qt5Widgets_DEFINITIONS})
ENDIF()

IF(${USE_QT_VERSION} MATCHES "6")
    ADD_DEFINITIONS( ${Qt6Widgets_DEFINITIONS})
ENDIF()

ADD_EXECUTABLE(${CMAKE_PROJECT_NAME}
    ${APP_SOURCES} 
    ${MAIN_SOURCES}
    ${OPT_SOURCES}
    ${APP_HEADERS_MOC} 
    ${APP_FORMS_HEADERS} 
    ${APP_RESOURCES_RCC}
)


IF(${USE_QT_VERSION} MATCHES "4")
    TARGET_LINK_LIBRARIES(${CMAKE_PROJECT_NAME} ${QT_LIBRARIES} httrack)
ENDIF()

IF(${USE_QT_VERSION} MATCHES "5")
    TARGET_LINK_LIBRARIES(${CMAKE_PROJECT_NAME} ${Qt5Widgets_LIBRARIES} ${Qt5DBus_LIBRARIES} httrack)
ENDIF()

IF(${USE_QT_VERSION} MATCHES "6")
    TARGET_LINK_LIBRARIES(${CMAKE_PROJECT_NAME} ${Qt6Widgets_LIBRARIES} ${Qt6DBus_LIBRARIES} httrack)
ENDIF()

ADD_CUSTOM_TARGET (tags
    COMMAND  ctags -R -f tags ${CMAKE_SOURCE_DIR}/sources/main ${CMAKE_SOURCE_DIR}/sources/options
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
)
# MESSAGE("CMAKE_SOURCE_DIR main ${CMAKE_SOURCE_DIR}")
# MESSAGE("CMAKE_CURRENT_BINARY_DIR main ${CMAKE_CURRENT_BINARY_DIR}")
# INCLUDE_DIRECTORIES(${CMAKE_CURRENT_BINARY_DIR})


# Setup module enabled/disabled defaults ...
IF(WIN32)
    SET(HTTRAQT_BUILD_GLX_MODULE_DEFAULT OFF)
    SET(HTTRAQT_BUILD_OSX_MODULE_DEFAULT OFF)
    SET(HTTRAQT_BUILD_VIRTUAL_OFFSCREEN_MODULE_DEFAULT OFF)
ENDIF()

IF(UNIX AND NOT APPLE)
    SET(HTTRAQT_BUILD_GLX_MODULE_DEFAULT OFF)
    SET(HTTRAQT_BUILD_OSX_MODULE_DEFAULT OFF)
    SET(HTTRAQT_BUILD_VIRTUAL_OFFSCREEN_MODULE_DEFAULT OFF)
ENDIF()

IF(APPLE)
    SET(HTTRAQT_BUILD_GLX_MODULE_DEFAULT OFF)
    SET(HTTRAQT_BUILD_OSX_MODULE_DEFAULT ON)
    SET(HTTRAQT_BUILD_VIRTUAL_OFFSCREEN_MODULE_DEFAULT OFF)
ENDIF()


OPTION(HTTRAQT_ENABLE_SYMBOL_VISIBILITY "Minimize the number of symbols exported from shared libraries." ${HTTRAQT_ENABLE_SYMBOL_VISIBILITY_DEFAULT})
MARK_AS_ADVANCED(HTTRAQT_ENABLE_SYMBOL_VISIBILITY)

# OPTION(HTTRAQT_ENABLE_TESTING "Build the HTTraQt regression test suite." OFF)
# SET(BUILD_TESTING ${HTTRAQT_ENABLE_TESTING} CACHE INTERNAL "" FORCE)
# INCLUDE(CTest)
# MARK_AS_ADVANCED(DART_TESTING_TIMEOUT)
# IF(HTTRAQT_ENABLE_TESTING)
#     CMAKE_MINIMUM_REQUIRED(VERSION 2.6.1 FATAL_ERROR)
#     CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/CTestCustom.cmake.in ${CMAKE_CURRENT_BINARY_DIR}/CTestCustom.cmake @ONLY)
# ENDIF(HTTRAQT_ENABLE_TESTING)

# Find required external packages
HTTRAQT_CHECK_REQUIRED_DEPENDENCY(HTTRAQT_HTTRACK_FOUND "libhttrack2" "http://www.httrack.com" "")
# HTTRAQT_CHECK_OPTIONAL_DEPENDENCY(HTTRAQT_BUILD_3DS_IO_MODULE HTTRAQT_3DS_FOUND "lib3ds")

# Capture system configuration
INCLUDE(SystemConfiguration)

# Win32 configuration
IF(WIN32)
    IF(NOT MSVC)
        SET(CMAKE_EXE_LINKER_FLAGS "-Wl,--enable-runtime-pseudo-reloc" CACHE STRING "" FORCE)
        SET(CMAKE_SHARED_LINKER_FLAGS "-Wl,--enable-runtime-pseudo-reloc -Wl,--export-all-symbols" CACHE STRING "" FORCE)
    ENDIF()
ENDIF()

# Setup output directories ...
SET(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${HTTRAQT_BINARY_DIR}/bin)

SET(HTTRAQT_LIBDIR lib) # Allows us to handle 64-bit libs if/when it becomes necessary.
IF(WIN32)
    SET(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${HTTRAQT_BINARY_DIR}/bin)
ELSE()
    SET(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${HTTRAQT_BINARY_DIR}/${HTTRAQT_LIBDIR})
ENDIF()

# Setup a macro for compiling resources ...
MACRO(HTTRAQT_COMPILE_RESOURCE OUTPUT INPUT RESOURCE_PATH)

    SET(INPUT_FILE "${CMAKE_CURRENT_SOURCE_DIR}/${INPUT}")
    SET(OUTPUT_FILE "${CMAKE_CURRENT_BINARY_DIR}/${INPUT}.cpp")
    GET_FILENAME_COMPONENT(OUTPUT_PATH ${OUTPUT_FILE} PATH)

    GET_TARGET_PROPERTY(HTTRAQT_RESOURCE_COMPILER httraqt-resource-compiler LOCATION)

    ADD_CUSTOM_COMMAND(
        DEPENDS httraqt-resource-compiler
        DEPENDS ${INPUT_FILE}
        COMMAND ${CMAKE_COMMAND} -E make_directory ${OUTPUT_PATH}
        COMMAND ${HTTRAQT_RESOURCE_COMPILER} --input ${INPUT_FILE} --path \"<path>${RESOURCE_PATH}</path>\" --output ${OUTPUT_FILE}
        OUTPUT ${OUTPUT_FILE}
        COMMENT "Compiling resource ${INPUT_FILE}"
        )

=== distribution/CMakeLists.txt ===
# Setup automatic generation of the changelog
MESSAGE(STATUS "CPack for Linux configuration..." )

SET( CPACK_SOURCE_PACKAGE_FILE_NAME "httraqt-${HTTRAQT_VERSION}" )
SET( CPACK_SOURCE_IGNORE_FILES
    "/\\\\.svn/"
    "/\\\\.kdev4/"
    "/\\\\.git/"
    "/pics/"
    "/build/"
    "~$"
    "\\\\.pcs$"
#     "TODO.txt"
#     "CMakeLists.txt.user"
#     "/doxygen/"
#     "${CMAKE_BINARY_DIR}"
)


# --- Package generation
SET( HTTRAQT_CPACK_BUILD_CONFIG "Release_and_Debug" )
SET( HTTRAQT_CPACK_PACKAGE_NAME ${CMAKE_PROJECT_NAME})
SET( HTTRAQT_CPACK_PACKAGE_VENDOR "KarboSoft" )
SET( HTTRAQT_CPACK_PACKAGE_INSTALL_DIRECTORY "HTTraQt ${HTTRAQT_VERSION}" )
SET( HTTRAQT_CPACK_PACKAGE_INSTALL_REGISTRY_KEY "HTTraQt ${HTTRAQT_VERSION}" )
SET( HTTRAQT_CPACK_PACKAGE_HOMEPAGE "http://httraqt.sourceforge.net/" )


# Setup global packaging parameters ...
SET( HTTRAQT_CPACK_INSTALL_CMAKE_PROJECTS "${CURRENT_BUILD_DIR};httraqt;ALL;/" )
# MESSAGE("HTTRAQT_BINARY_DIR ${CURRENT_BUILD_DIR}")
SET( HTTRAQT_CPACK_PACKAGE_DESCRIPTION "HTTraQt free GUI for httrack library." )
SET( HTTRAQT_CPACK_PACKAGE_FILE_NAME "httraqt-setup-${HTTRAQT_VERSION}" )
SET( HTTRAQT_CPACK_PACKAGE_VERSION "${HTTRAQT_VERSION}" )
SET( HTTRAQT_CPACK_RESOURCE_FILE_LICENSE "${PROJECT_SOURCE_DIR}/LICENCE" )
SET( HTTRAQT_CPACK_SOURCE_IGNORE_FILES "/CVS/;/.svn/;/.hg/" )
SET( HTTRAQT_CPACK_SOURCE_INSTALLED_DIRECTORIES "${PROJECT_SOURCE_DIR};/" )
SET( HTTRAQT_CPACK_SOURCE_PACKAGE_FILE_NAME "httraqt-source-${HTTRAQT_VERSION}" )

# SET( HTTRAQT_CPACK_PACKAGE_NAME ${CMAKE_PROJECT_NAME} )
SET( HTTRAQT_CPACK_PACKAGE_VERSION ${HTTRAQT_VERSION} )
SET( HTTRAQT_CPACK_PACKAGE_RELEASE 0 )
SET( HTTRAQT_CPACK_PACKAGE_MAINTAINER "Eduard Kalinowski <eduard_kalinowski@yahoo.de>" )
SET( HTTRAQT_CPACK_PACKAGE_MAINTAINER_NAME "Eduard Kalinowski" )
SET( HTTRAQT_CPACK_PACKAGE_MAINTAINER_EMAIL "eduard_kalinowski@yahoo.de" )
SET( HTTRAQT_CPACK_PACKAGE_DESCRIPTION "HTTraQt is the website copier for offline browsing" )
SET( HTTRAQT_CPACK_PACKAGE_DESCRIPTION_SUMMARY "HTTraQt network tool" )
# SET( PACKAGE_DEPENDS ${hugr_dependencies} )


# SET( HTTRAQT_CPACK_PACKAGE_DEPENDS "${HTTRAQT_CPACK_PACKAGE_SHLIBDEPS}" )

#SET( HTTRAQT_CPACK_PACKAGE_DEPENDS "libhttrack2, libqtcore4, libqtgui4, libc6, libstdc++6" )
SET( HTTRAQT_CPACK_PACKAGE_DEPENDS "libhttrack2, ${HTTRAQT_CPACK_PACKAGE_DEPENDS}" )
# SET( PACKAGE_DEPENDS "libc6 (>= 2.1.3), libhttrack (>= 3.42.1), libqtcore4 (>= 4:4.6.1), libqtgui4 (>= 4:4.5.3), libstdc++6 (>= 4.1.1)" )


SET( HTTRAQT_CPACK_PACKAGE_GROUP "Groupe" )
SET( HTTRAQT_CPACK_PACKAGE_LICENSE "GPL3" )

# ADD_CUSTOM_TARGET(changelog
# 	COMMAND ${GITCOMMAND} log > ${HTTRAQT_BINARY_DIR}/ChangeLog
# 	WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}
# 	)

# Setup convenience targets for tagging and branching
# SET( HTTRAQT_VERSION_TAG "httraqt-${HTTRAQT_MAJOR_VERSION}.${HTTRAQT_MINOR_VERSION}.${HTTRAQT_RELEASE_VERSION}.${HTTRAQT_BUILD_VERSION}" )
# SET( HTTRAQT_VERSION_TAG "httraqt-${HTTRAQT_VERSION}" )
# ADD_CUSTOM_TARGET(tag-version
# 	COMMAND ${GITCOMMAND} tag ${HTTRAQT_VERSION_TAG}
# 	WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}
# 	)

#SET( HTTRAQT_BRANCH_TAG "httraqt-release-${HTTRAQT_MAJOR_VERSION}.${HTTRAQT_MINOR_VERSION}" )
#ADD_CUSTOM_TARGET(tag-branch
#	COMMAND ${SVNCOMMAND} cp ${HTTRAQT_SVN_TRUNK}
#	${HTTRAQT_SVN_BRANCHES}/${HTTRAQT_BRANCH_TAG} -m "COMP: Branched HTTraQt Version ${HTTRAQT_MAJOR_VERSION}.${HTTRAQT_MINOR_VERSION}"
#	WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}
#	)
# MESSAGE("CMAKE_CURRENT_SOURCE_DIR distr ${CMAKE_CURRENT_SOURCE_DIR} : ${PROJECT_SOURCE_DIR}")
# Get a SourceForge username so we can upload distributables to the FRS
IF(WIN32)
	SET( HTTRAQT_SOURCEFORGE_USERNAME "$ENV{USERNAME}" CACHE STRING "SourceForge user account name, for uploading distribution files." )
ELSE(WIN32)
	SET( HTTRAQT_SOURCEFORGE_USERNAME "$ENV{USER}" CACHE STRING "SourceForge user account name, for uploading distribution files." )
ENDIF(WIN32)
MARK_AS_ADVANCED(HTTRAQT_SOURCEFORGE_USERNAME)



# Setup some macros that can be used by the platform-specific distribution logic
MACRO(HTTRAQT_CHECK_INSTALLED_VERSION FOUND PACKAGE EXPECTED)
	IF(NOT ${FOUND} STREQUAL ${EXPECTED})
		MESSAGE(SEND_ERROR "Found ${PACKAGE} version ${FOUND} - for installation, version ${EXPECTED} is required." )
	ENDIF(NOT ${FOUND} STREQUAL ${EXPECTED})
ENDMACRO(HTTRAQT_CHECK_INSTALLED_VERSION)



# Generate source packages
# ADD_SUBDIRECTORY(source)
INCLUDE(CPack)

# Generate platform-specific binary packages
IF(APPLE)
	ADD_SUBDIRECTORY(osx)
ENDIF(APPLE)

IF(UNIX AND NOT APPLE)
	ADD_SUBDIRECTORY(posix)
ENDIF(UNIX AND NOT APPLE)

IF(WIN32)
	ADD_SUBDIRECTORY(win32)
ENDIF(WIN32)

=== distribution/posix/CMakeLists.txt ===
SET(CPACK_STRIP_FILES TRUE)
SET(CMAKE_INSTALL_PREFIX "/usr")

#MESSAGE("CMAKE_INSTALL_PREFIX ${CMAKE_INSTALL_PREFIX}")

SET( CPACK_PACKAGE_GROUP "${HTTRAQT_CPACK_PACKAGE_GROUP}" )
SET( CPACK_PACKAGE_LICENSE "${HTTRAQT_CPACK_PACKAGE_LICENSE}" )
SET( CPACK_PACKAGE_SHLIBDEPS "${HTTRAQT_CPACK_PACKAGE_SHLIBDEPS}" )
# SET( CPACK_PACKAGE_DEPENDS "${HTTRAQT_CPACK_PACKAGE_DEPENDS}" )

INSTALL(PROGRAMS "${CURRENT_BUILD_DIR}/httraqt" DESTINATION bin COMPONENT applications)
INSTALL(DIRECTORY "${PROJECT_SOURCE_DIR}/icons" DESTINATION "/usr/share/" FILES_MATCHING PATTERN "*.*") 
INSTALL(DIRECTORY "${PROJECT_SOURCE_DIR}/lang" DESTINATION "/usr/share/httraqt/" FILES_MATCHING PATTERN "*.*") 
INSTALL(DIRECTORY "${PROJECT_SOURCE_DIR}/help" DESTINATION "/usr/share/httraqt/" FILES_MATCHING PATTERN "*.*") 
# MESSAGE("PROJECT_SOURCE_DIR ${PROJECT_SOURCE_DIR}")

SET( desktop "${PROJECT_SOURCE_DIR}/desktop/httraqt.desktop")

INSTALL(FILES ${desktop}
        DESTINATION "/usr/share/applications/"
        PERMISSIONS OWNER_READ GROUP_READ WORLD_READ)
        
SET(CPACK_INSTALL_CMAKE_PROJECTS "${HTTRAQT_CPACK_INSTALL_CMAKE_PROJECTS}")

SET(HTTRAQT_PACKAGE_DIRECTORY "${CURRENT_BUILD_DIR}")
# FILE(MAKE_DIRECTORY "${HTTRAQT_PACKAGE_DIRECTORY}")
# MESSAGE("CMAKE_CURRENT_SOURCE_DIR posix ${CMAKE_CURRENT_SOURCE_DIR}")
# MESSAGE("DIR: ${CMAKE_CURRENT_SOURCE_DIR}")

# if not defined
IF(NOT DEBIAN_ARCHITECTURE)
    execute_process(
      COMMAND dpkg --print-architecture
      OUTPUT_VARIABLE DEBIAN_ARCHITECTURE
      OUTPUT_STRIP_TRAILING_WHITESPACE
    )
  #SET(DEBIAN_ARCHITECTURE i386) #dpkg --print-architecture is always i386 on intel
ENDIF(NOT DEBIAN_ARCHITECTURE)

IF(DEBIAN_ARCHITECTURE)
    MESSAGE("DEBIAN_ARCHITECTURE ${DEBIAN_ARCHITECTURE}")
    SET( HTTRAQT_CPACK_PACKAGE_FILE_NAME "httraqt-${HTTRAQT_VERSION}-${DEBIAN_ARCHITECTURE}" )
    
    CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/package-binary-deb.cpack.in ${CMAKE_CURRENT_BINARY_DIR}/package-binary-deb.cpack)
    ADD_CUSTOM_TARGET(package-binary-deb
        WORKING_DIRECTORY "${HTTRAQT_PACKAGE_DIRECTORY}"
        COMMAND ${CMAKE_CPACK_COMMAND} --config ${CMAKE_CURRENT_BINARY_DIR}/package-binary-deb.cpack
        )
ENDIF()

IF(NOT RPM_ARCHITECTURE)
    FIND_PROGRAM(RPMBUILD
        NAMES rpmbuild
        PATHS "/usr/bin")

    IF ( RPMBUILD )
        GET_FILENAME_COMPONENT(RPMBUILD_PATH ${RPMBUILD} ABSOLUTE)
        MESSAGE(STATUS "Found rpmbuild : ${RPMBUILD_PATH}")
        SET(RPMBUILD_FOUND "YES")
        execute_process(
           COMMAND arch
           OUTPUT_VARIABLE RPM_ARCHITECTURE
           OUTPUT_STRIP_TRAILING_WHITESPACE
        )
    ENDIF ( RPMBUILD )
ENDIF()

IF(RPM_ARCHITECTURE)
    MESSAGE("RPM_ARCHITECTURE ${RPM_ARCHITECTURE}")
    SET( HTTRAQT_CPACK_PACKAGE_FILE_NAME "httraqt-${HTTRAQT_VERSION}-${RPM_ARCHITECTURE}" )
    
    CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/package-binary-rpm.cpack.in ${CMAKE_CURRENT_BINARY_DIR}/package-binary-rpm.cpack)
    ADD_CUSTOM_TARGET(package-binary-rpm
        WORKING_DIRECTORY "${HTTRAQT_PACKAGE_DIRECTORY}"
        COMMAND ${CMAKE_CPACK_COMMAND} --config ${CMAKE_CURRENT_BINARY_DIR}/package-binary-rpm.cpack
        )
ENDIF()

# Generate self-extracting tarballs
CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/package-binary-stgz.cpack.in ${CMAKE_CURRENT_BINARY_DIR}/package-binary-stgz.cpack)
ADD_CUSTOM_TARGET(package-binary-stgz
        WORKING_DIRECTORY "${HTTRAQT_PACKAGE_DIRECTORY}"
        COMMAND ${CMAKE_CPACK_COMMAND} --config ${CMAKE_CURRENT_BINARY_DIR}/package-binary-stgz.cpack
        )

# Generate tarballs
CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/package-binary-tbz2.cpack.in ${CMAKE_CURRENT_BINARY_DIR}/package-binary-tbz2.cpack)
ADD_CUSTOM_TARGET(package-binary-tbz2
        WORKING_DIRECTORY "${HTTRAQT_PACKAGE_DIRECTORY}"
        COMMAND ${CMAKE_CPACK_COMMAND} --config ${CMAKE_CURRENT_BINARY_DIR}/package-binary-tbz2.cpack
        )

CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/package-binary-tgz.cpack.in ${CMAKE_CURRENT_BINARY_DIR}/package-binary-tgz.cpack)
ADD_CUSTOM_TARGET(package-binary-tgz
        WORKING_DIRECTORY "${HTTRAQT_PACKAGE_DIRECTORY}"
        COMMAND ${CMAKE_CPACK_COMMAND} --config ${CMAKE_CURRENT_BINARY_DIR}/package-binary-tgz.cpack
        )

# Note ... we intentionally don't provide upload capability for Posix packages, and leave distribution to the experts

=== distribution/win32/CMakeLists.txt ===
OPTION(HTTRAQT_INSTALL_AQSIS "Include Aqsis in the HTTraQt installer" OFF)
OPTION(HTTRAQT_INSTALL_BOOST "Include Boost in the HTTraQt installer" OFF)
OPTION(HTTRAQT_INSTALL_CGKIT "Include cgkit in the HTTraQt installer" OFF)
OPTION(HTTRAQT_INSTALL_GTKMM "Include gtkmm in the HTTraQt installer" OFF)
OPTION(HTTRAQT_INSTALL_PYGTK "Include PyGTK in the HTTraQt installer" OFF)
OPTION(HTTRAQT_INSTALL_PYOPENGL "Include PyOpenGL in the HTTraQt installer" OFF)
OPTION(HTTRAQT_INSTALL_PYTHON "Include Python in the HTTraQt installer" OFF)

HTTRAQT_CHECK_INSTALLED_PYTHON_DEPENDENCY(HTTRAQT_INSTALL_CGKIT)
HTTRAQT_CHECK_INSTALLED_PYTHON_DEPENDENCY(HTTRAQT_INSTALL_PYGTK)
HTTRAQT_CHECK_INSTALLED_PYTHON_DEPENDENCY(HTTRAQT_INSTALL_PYOPENGL)

#install mingwm10.dll
FIND_PROGRAM(HTTRAQT_MINGW_GCC mingw32-gcc.exe
	C:/mingw/bin
	DOC "Path to the MinGW GCC command")
MARK_AS_ADVANCED(HTTRAQT_MINGW_GCC)

GET_FILENAME_COMPONENT(HTTRAQT_MINGW_PATH ${HTTRAQT_MINGW_GCC} PATH)
INSTALL(FILES ${HTTRAQT_MINGW_PATH}/mingwm10.dll DESTINATION bin)

IF(HTTRAQT_INSTALL_AQSIS)
	FIND_PROGRAM(HTTRAQT_AQSIS_COMMAND aqsis.exe
		DOC "Path to an installed aqsis.exe."
		)
	MARK_AS_ADVANCED(HTTRAQT_AQSIS_COMMAND)

	IF(NOT HTTRAQT_AQSIS_COMMAND)
		MESSAGE(SEND_ERROR "Could not locate aqsis.exe.")
	ENDIF(NOT HTTRAQT_AQSIS_COMMAND)

	IF(NOT HTTRAQT_BUILD_BUNDLED_RENDERMAN_ENGINES_MODULE)
		MESSAGE(SEND_ERROR "HTTRAQT_INSTALL_AQSIS requires HTTRAQT_BUILD_BUNDLED_RENDERMAN_ENGINES_MODULE")
	ENDIF(NOT HTTRAQT_BUILD_BUNDLED_RENDERMAN_ENGINES_MODULE)

	EXECUTE_PROCESS(
		COMMAND ${HTTRAQT_AQSIS_COMMAND} --version
		OUTPUT_VARIABLE HTTRAQT_AQSIS_VERSION
		)
	IF(HTTRAQT_AQSIS_VERSION)
		STRING(REGEX REPLACE " \\(revision.*" "" HTTRAQT_AQSIS_VERSION ${HTTRAQT_AQSIS_VERSION})
		STRING(REGEX REPLACE "aqsis version " "" HTTRAQT_AQSIS_VERSION ${HTTRAQT_AQSIS_VERSION})
		HTTRAQT_CHECK_INSTALLED_VERSION(${HTTRAQT_AQSIS_VERSION} "Aqsis" "1.6.0")
	ELSE(HTTRAQT_AQSIS_VERSION)
		MESSAGE(SEND_ERROR "Error determining Aqsis version.")
	ENDIF(HTTRAQT_AQSIS_VERSION)

	GET_FILENAME_COMPONENT(HTTRAQT_AQSIS_PATH ${HTTRAQT_AQSIS_COMMAND} PATH)
	INSTALL(DIRECTORY ${HTTRAQT_AQSIS_PATH}/ DESTINATION bin
	    USE_SOURCE_PERMISSIONS
	    PATTERN aqsisrc EXCLUDE
		)
	# Install generic aqsisrc, omitting paths (those are set at runtime through command line options)
	INSTALL(FILES ${CMAKE_CURRENT_SOURCE_DIR}/aqsisrc DESTINATION bin)
	#install msvcrt, needed since aqsis 1.4
	FIND_PROGRAM(VCREDIST_X86_2005 vcredist_x86_2005.exe DOC "Path to the Visual Studio C++ 2005 SP1 redistributable")
	INSTALL(FILES ${VCREDIST_X86_2005} DESTINATION redist)
	SET(CPACK_NSIS_EXTRA_INSTALL_COMMANDS
		"ExecWait '\\\"$INSTDIR\\\\redist\\\\vcredist_x86_2005.exe\\\"'")
ENDIF(HTTRAQT_INSTALL_AQSIS)

IF(HTTRAQT_INSTALL_BOOST)
	set(aPrevBoostLib "")
    foreach(aBoostLib ${Boost_LIBRARIES})
        if(NOT (aBoostLib STREQUAL "debug" OR aBoostLib STREQUAL "optimized" OR aPrevBoostLib STREQUAL "debug"))
            INSTALL(FILES ${aBoostLib} DESTINATION bin)
        endif()
        set(aPrevBoostLib ${aBoostLib})
    endforeach(aBoostLib)
ENDIF(HTTRAQT_INSTALL_BOOST)

IF(HTTRAQT_BUILD_COLLADA_IO_MODULE)
    INSTALL(FILES ${HTTRAQT_COLLADA_LIBRARY} DESTINATION bin)
ENDIF(HTTRAQT_BUILD_COLLADA_IO_MODULE)

IF(HTTRAQT_INSTALL_GTKMM)
	INCLUDE(HTTRAQTDFindPkgConfig)
	
	PKG_CHECK_MODULES(ATK atk)
	PKG_CHECK_MODULES(ATKMM atkmm-1.6)
	PKG_CHECK_MODULES(CAIRO cairo)
	PKG_CHECK_MODULES(CAIROMM cairomm-1.0)
	PKG_CHECK_MODULES(GDK gdk-2.0)
	PKG_CHECK_MODULES(GDKGLEXT gdkglext-1.0)
	PKG_CHECK_MODULES(GDKGLEXTW gdkglext-win32-1.0)
	PKG_CHECK_MODULES(GDKMM gdkmm-2.4)
	PKG_CHECK_MODULES(GTK gtk+-2.0)
	PKG_CHECK_MODULES(GTKMM gtkmm-2.4)

	HTTRAQT_CHECK_INSTALLED_VERSION(${ATK_VERSION} "atk" "1.24.0")
	HTTRAQT_CHECK_INSTALLED_VERSION(${ATKMM_VERSION} "atkmm" "2.14.3")
	HTTRAQT_CHECK_INSTALLED_VERSION(${CAIRO_VERSION} "cairo" "1.8.6")
	HTTRAQT_CHECK_INSTALLED_VERSION(${CAIROMM_VERSION} "cairomm" "1.8.0")
	HTTRAQT_CHECK_INSTALLED_VERSION(${GDK_VERSION} "gdk" "2.14.7")
	HTTRAQT_CHECK_INSTALLED_VERSION(${GDKGLEXT_VERSION} "gdkglext" "1.2.0")
	HTTRAQT_CHECK_INSTALLED_VERSION(${GDKGLEXTW_VERSION} "gdkglext-win32" "1.2.0")
	HTTRAQT_CHECK_INSTALLED_VERSION(${GDKMM_VERSION} "gdkmm" "2.14.3")
	HTTRAQT_CHECK_INSTALLED_VERSION(${GTK_VERSION} "gtk" "2.14.7")
	HTTRAQT_CHECK_INSTALLED_VERSION(${GTKMM_VERSION} "gtkmm" "2.14.3")

	# This is an ugly hack, we should be able to detect this automatically, but I'm feeling lazy ...
	SET(HTTRAQT_GTK_DIR "c:/gtk" CACHE PATH "Root directory containing GTK/gtkmm")
	MARK_AS_ADVANCED(HTTRAQT_GTK_DIR)

	INSTALL(DIRECTORY ${HTTRAQT_GTK_DIR}/bin/ DESTINATION bin
		USE_SOURCE_PERMISSIONS
		PATTERN *.pdb EXCLUDE
		PATTERN *-config EXCLUDE
		PATTERN *glade* EXCLUDE
		PATTERN *xml++* EXCLUDE
		PATTERN atkmm-1.6d.dll EXCLUDE
		PATTERN gdkmm-2.4d.dll EXCLUDE
		PATTERN gettext.sh EXCLUDE
		PATTERN glib-gettextize EXCLUDE
		PATTERN glib-mkenums EXCLUDE
		PATTERN glibmm-2.4d.dll EXCLUDE
		PATTERN gtkaio.sh EXCLUDE
		PATTERN gtkautogen EXCLUDE
		PATTERN gtkconfigure EXCLUDE
		PATTERN gtkmm-2.4d.dll EXCLUDE
		PATTERN msg*.exe EXCLUDE
		PATTERN pangomm-1.4d.dll EXCLUDE
		PATTERN sigc-2.0d.dll EXCLUDE
		)

	INSTALL(DIRECTORY ${HTTRAQT_GTK_DIR}/etc/ DESTINATION etc
		USE_SOURCE_PERMISSIONS
		)

	INSTALL(DIRECTORY ${HTTRAQT_GTK_DIR}/lib/ DESTINATION ${HTTRAQT_LIBDIR}
		USE_SOURCE_PERMISSIONS
		PATTERN *.a EXCLUDE
		PATTERN *.lib EXCLUDE
		PATTERN *.pdb EXCLUDE
		PATTERN *glade* EXCLUDE
		PATTERN gdkmm-2.4 EXCLUDE
		PATTERN glib-2.0 EXCLUDE
		PATTERN glibmm-2.4 EXCLUDE
		PATTERN gtkglext-1.0 EXCLUDE
		PATTERN gtkmm-2.4 EXCLUDE
		PATTERN include EXCLUDE
		PATTERN libxml++-2.6 EXCLUDE
		PATTERN pkgconfig EXCLUDE
		PATTERN sigc++-2.0 EXCLUDE
		)

	# Override the default gtkrc file with our own
	INSTALL(FILES ${CMAKE_CURRENT_SOURCE_DIR}/gtkrc DESTINATION etc/gtk-2.0)
ENDIF(HTTRAQT_INSTALL_GTKMM)

IF(HTTRAQT_INSTALL_PYTHON)
	FIND_PROGRAM(HTTRAQT_PYTHON_COMMAND python.exe
		PATHS "c:/python26"
		DOC "Path to an installed python.exe."
		)
	MARK_AS_ADVANCED(HTTRAQT_PYTHON_COMMAND)
	
	IF(NOT HTTRAQT_PYTHON_COMMAND)
		MESSAGE(SEND_ERROR "Could not locate python.exe.")
	ENDIF(NOT HTTRAQT_PYTHON_COMMAND)

	FIND_PROGRAM(HTTRAQT_PYTHON_LIBRARY python26.dll
		DOC "Path to the installed python26.dll"
		)
	MARK_AS_ADVANCED(HTTRAQT_PYTHON_LIBRARY)

	IF(NOT HTTRAQT_PYTHON_LIBRARY)
		MESSAGE(SEND_ERROR "Could not locate python26.dll.")
	ENDIF(NOT HTTRAQT_PYTHON_LIBRARY)

	EXECUTE_PROCESS(
		COMMAND ${HTTRAQT_PYTHON_COMMAND} -V
		ERROR_VARIABLE HTTRAQT_PYTHON_VERSION
		)

	IF(HTTRAQT_PYTHON_VERSION)
		STRING(REGEX REPLACE "^Python ([0-9]+\\.[0-9]+\\.[0-9]+).*" "\\1" HTTRAQT_PYTHON_VERSION ${HTTRAQT_PYTHON_VERSION})
		HTTRAQT_CHECK_INSTALLED_VERSION(${HTTRAQT_PYTHON_VERSION} "Python" "2.6.1")
	ELSE(HTTRAQT_PYTHON_VERSION)
		MESSAGE(SEND_ERROR "Error determining Python version.")
	ENDIF(HTTRAQT_PYTHON_VERSION)

	INSTALL(PROGRAMS
		${HTTRAQT_PYTHON_COMMAND}
		${HTTRAQT_PYTHON_LIBRARY}
		DESTINATION bin
		)

	GET_FILENAME_COMPONENT(HTTRAQT_PYTHON_PATH ${HTTRAQT_PYTHON_COMMAND} PATH)
	FILE(GLOB HTTRAQT_PYTHON_MODULES ${HTTRAQT_PYTHON_PATH}/Lib/*.py)
	INSTALL(PROGRAMS
		${HTTRAQT_PYTHON_MODULES}
		DESTINATION ${HTTRAQT_LIBDIR}
		)

	SET(HTTRAQT_PYTHON_SITE_PACKAGES ${HTTRAQT_PYTHON_PATH}/Lib/site-packages)

	IF(HTTRAQT_INSTALL_CGKIT)
		EXECUTE_PROCESS(
			COMMAND ${HTTRAQT_PYTHON_COMMAND} -c "import cgkit.cgkitinfo;print cgkit.cgkitinfo.version"
			OUTPUT_VARIABLE HTTRAQT_CGKIT_VERSION
			)

		IF(HTTRAQT_CGKIT_VERSION)
			STRING(REGEX REPLACE "^([0-9]+\\.[0-9]+\\.[0-9]+[^ ]*).*" "\\1" HTTRAQT_CGKIT_VERSION ${HTTRAQT_CGKIT_VERSION})
			HTTRAQT_CHECK_INSTALLED_VERSION(${HTTRAQT_CGKIT_VERSION} "cgkit" "2.0.0alpha8")
		ELSE(HTTRAQT_CGKIT_VERSION)
			MESSAGE(SEND_ERROR "Error determining cgkit version.")
		ENDIF(HTTRAQT_CGKIT_VERSION)

		INSTALL(DIRECTORY
			${HTTRAQT_PYTHON_SITE_PACKAGES}/cgkit
			DESTINATION ${HTTRAQT_LIBDIR}/site-packages
			PATTERN *.pyc EXCLUDE
			PATTERN *.pyo EXCLUDE
			)
	ENDIF(HTTRAQT_INSTALL_CGKIT)

	IF(HTTRAQT_INSTALL_PYGTK)
		EXECUTE_PROCESS(
			COMMAND ${HTTRAQT_PYTHON_COMMAND} -c "import gtk;print gtk.pygtk_version"
			OUTPUT_VARIABLE HTTRAQT_PYGTK_VERSION
			)

		IF(HTTRAQT_PYGTK_VERSION)
			STRING(REGEX REPLACE ".*([0-9]+), ([0-9]+), ([0-9]+).*" "\\1.\\2.\\3" HTTRAQT_PYGTK_VERSION ${HTTRAQT_PYGTK_VERSION})
			HTTRAQT_CHECK_INSTALLED_VERSION(${HTTRAQT_PYGTK_VERSION} "PyGTK" "2.12.1")
		ELSE(HTTRAQT_PYGTK_VERSION)
			MESSAGE(SEND_ERROR "Error determining PyGTK version.")
		ENDIF(HTTRAQT_PYGTK_VERSION)

		INSTALL(DIRECTORY
			${HTTRAQT_PYTHON_SITE_PACKAGES}/cairo
			DESTINATION ${HTTRAQT_LIBDIR}/site-packages
			PATTERN *.pyc EXCLUDE
			PATTERN *.pyo EXCLUDE
			)
		INSTALL(DIRECTORY
			${HTTRAQT_PYTHON_SITE_PACKAGES}/gtk-2.0
			DESTINATION ${HTTRAQT_LIBDIR}/site-packages
			PATTERN *.pyc EXCLUDE
			PATTERN *.pyo EXCLUDE
			)
		INSTALL(PROGRAMS
			${HTTRAQT_PYTHON_SITE_PACKAGES}/pygtk.py
			DESTINATION ${HTTRAQT_LIBDIR}/site-packages
			)
	ENDIF(HTTRAQT_INSTALL_PYGTK)

	IF(HTTRAQT_INSTALL_PYOPENGL)
		EXECUTE_PROCESS(
			COMMAND ${HTTRAQT_PYTHON_COMMAND} -c "import OpenGL.version;print OpenGL.version.__version__"
			OUTPUT_VARIABLE HTTRAQT_PYOPENGL_VERSION
			)
		IF(HTTRAQT_PYOPENGL_VERSION)
			STRING(REGEX REPLACE "^([0-9]+\\.[0-9]+\\.[0-9]+).*" "\\1" HTTRAQT_PYOPENGL_VERSION ${HTTRAQT_PYOPENGL_VERSION})
			HTTRAQT_CHECK_INSTALLED_VERSION(${HTTRAQT_PYOPENGL_VERSION} "PyOpenGL" "3.0.0")
		ELSE(HTTRAQT_PYOPENGL_VERSION)
			MESSAGE(SEND_ERROR "Error determining PyOpenGL version.")
		ENDIF(HTTRAQT_PYOPENGL_VERSION)

		INSTALL(DIRECTORY
			${HTTRAQT_PYTHON_SITE_PACKAGES}/OpenGL
			DESTINATION ${HTTRAQT_LIBDIR}/site-packages
			PATTERN *.pyc EXCLUDE
			PATTERN *.pyo EXCLUDE
			)
	ENDIF(HTTRAQT_INSTALL_PYOPENGL)

	#Needed for Python 2.6
	FIND_PROGRAM(VCREDIST_X86_2008 vcredist_x86_2008.exe DOC "Path to the Visual Studio C++ 2008 SP1 redistributable")
	INSTALL(FILES ${VCREDIST_X86_2008} DESTINATION redist)
	SET(CPACK_NSIS_EXTRA_INSTALL_COMMANDS
		"${CPACK_NSIS_EXTRA_INSTALL_COMMANDS}
			ExecWait '\\\"$INSTDIR\\\\redist\\\\vcredist_x86_2008.exe\\\"'")

ENDIF(HTTRAQT_INSTALL_PYTHON)

ADD_SUBDIRECTORY(nsis)

=== sources/main/CMakeLists.txt ===
#CMakeLists.txt

set(MAIN_SOURCES ${CMAKE_CURRENT_SOURCE_DIR}/translator.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/htinterface.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/options.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/httraqt.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/AboutDialog.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/buttonPanel.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/ConfirmTab.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/FinalTab.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/InsertUrlDialog.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/main.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/NewProjTab.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/OptionsTab.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/ProgressTab.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/StartTab.cpp
                PARENT_SCOPE)

set(MAIN_HEADERS ${CMAKE_CURRENT_SOURCE_DIR}/includes/httraqt.h
#                 ${CMAKE_CURRENT_SOURCE_DIR}/includes/htsnet.h
                ${CMAKE_CURRENT_SOURCE_DIR}/includes/htinterface.h
#                 ${CMAKE_CURRENT_SOURCE_DIR}/includes/htsstrings.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/includes/options.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/includes/translator.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/includes/AboutDialog.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/includes/buttonPanel.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/includes/FinalTab.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/../version.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/includes/InsertUrlDialog.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/includes/NewProjTab.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/includes/ProgressTab.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/includes/ConfirmTab.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/includes/OptionsTab.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/includes/StartTab.h
                PARENT_SCOPE)

set(MAIN_FORMS  ${CMAKE_CURRENT_SOURCE_DIR}/forms/AboutDialog.ui
                ${CMAKE_CURRENT_SOURCE_DIR}/forms/buttonPanel.ui
                ${CMAKE_CURRENT_SOURCE_DIR}/forms/ConfirmTab.ui
                ${CMAKE_CURRENT_SOURCE_DIR}/forms/FinalTab.ui
                ${CMAKE_CURRENT_SOURCE_DIR}/forms/InsertUrlDialog.ui
                ${CMAKE_CURRENT_SOURCE_DIR}/forms/mainForm.ui
                ${CMAKE_CURRENT_SOURCE_DIR}/forms/NewProjTab.ui 
                ${CMAKE_CURRENT_SOURCE_DIR}/forms/OptionsTab.ui
                ${CMAKE_CURRENT_SOURCE_DIR}/forms/ProgressTab.ui 
                ${CMAKE_CURRENT_SOURCE_DIR}/forms/StartTab.ui
                PARENT_SCOPE)

#QT4_WRAP_CPP(MAIN_HEADERS_MOC ${MAIN_HEADERS})
#QT4_WRAP_UI(MAIN_FORMS_HEADERS ${MAIN_FORMS})


# cleanup $build/*.cpp~ on "make clean"
SET_DIRECTORY_PROPERTIES(PROPERTIES
    ADDITIONAL_MAKE_CLEAN_FILES "${CMAKE_CURRENT_SOURCE_DIR}/*~")

=== sources/options/CMakeLists.txt ===
#CMakeLists.txt

set(OPT_SOURCES ${CMAKE_CURRENT_SOURCE_DIR}/optionsbrowser.cpp
		${CMAKE_CURRENT_SOURCE_DIR}/optionsbuild.cpp
		${CMAKE_CURRENT_SOURCE_DIR}/OptionsDialog.cpp
		${CMAKE_CURRENT_SOURCE_DIR}/BuildStringDialog.cpp
		${CMAKE_CURRENT_SOURCE_DIR}/optionsexperts.cpp
		${CMAKE_CURRENT_SOURCE_DIR}/optionsflow.cpp
		${CMAKE_CURRENT_SOURCE_DIR}/optionslimits.cpp
		${CMAKE_CURRENT_SOURCE_DIR}/optionslinks.cpp
		${CMAKE_CURRENT_SOURCE_DIR}/optionslog.cpp
		${CMAKE_CURRENT_SOURCE_DIR}/optionsmime.cpp
		${CMAKE_CURRENT_SOURCE_DIR}/optionsproxy.cpp
		${CMAKE_CURRENT_SOURCE_DIR}/optionsrulez.cpp
		${CMAKE_CURRENT_SOURCE_DIR}/optionsspider.cpp
                PARENT_SCOPE)

set(OPT_HEADERS ${CMAKE_CURRENT_SOURCE_DIR}/includes/optionsbrowser.h
		${CMAKE_CURRENT_SOURCE_DIR}/includes/optionsbuild.h
		${CMAKE_CURRENT_SOURCE_DIR}/includes/OptionsDialog.h
		${CMAKE_CURRENT_SOURCE_DIR}/includes/BuildStringDialog.h
		${CMAKE_CURRENT_SOURCE_DIR}/includes/optionsexperts.h
		${CMAKE_CURRENT_SOURCE_DIR}/includes/optionsflow.h
		${CMAKE_CURRENT_SOURCE_DIR}/includes/optionslimits.h
		${CMAKE_CURRENT_SOURCE_DIR}/includes/optionslinks.h
		${CMAKE_CURRENT_SOURCE_DIR}/includes/optionslog.h
		${CMAKE_CURRENT_SOURCE_DIR}/includes/optionsmime.h
		${CMAKE_CURRENT_SOURCE_DIR}/includes/optionsproxy.h
		${CMAKE_CURRENT_SOURCE_DIR}/includes/optionsrulez.h
		${CMAKE_CURRENT_SOURCE_DIR}/includes/optionsspider.h
                PARENT_SCOPE)

set(OPT_FORMS ${CMAKE_CURRENT_SOURCE_DIR}/forms/OptionsBrowser.ui
	      ${CMAKE_CURRENT_SOURCE_DIR}/forms/OptionsBuild.ui
	      ${CMAKE_CURRENT_SOURCE_DIR}/forms/BuildStringDialog.ui
	      ${CMAKE_CURRENT_SOURCE_DIR}/forms/OptionsDialog.ui
	      ${CMAKE_CURRENT_SOURCE_DIR}/forms/OptionsExperts.ui
	      ${CMAKE_CURRENT_SOURCE_DIR}/forms/OptionsFlow.ui
	      ${CMAKE_CURRENT_SOURCE_DIR}/forms/OptionsLimits.ui
	      ${CMAKE_CURRENT_SOURCE_DIR}/forms/OptionsLinks.ui
	      ${CMAKE_CURRENT_SOURCE_DIR}/forms/OptionsLog.ui
	      ${CMAKE_CURRENT_SOURCE_DIR}/forms/OptionsMime.ui
	      ${CMAKE_CURRENT_SOURCE_DIR}/forms/OptionsProxy.ui
	      ${CMAKE_CURRENT_SOURCE_DIR}/forms/OptionsRulez.ui
	      ${CMAKE_CURRENT_SOURCE_DIR}/forms/OptionsSpider.ui
                PARENT_SCOPE)

# IF(${USE_QT_VERSION} MATCHES "4")
#     QT4_WRAP_CPP(OPT_HEADERS_MOC ${OPT_HEADERS})
#     QT4_WRAP_UI(OPT_FORMS_HEADERS ${OPT_FORMS})
# ENDIF()
# 
# IF(${USE_QT_VERSION} MATCHES "5")
#     QT5_WRAP_CPP(OPT_HEADERS_MOC ${OPT_HEADERS})
#     QT5_WRAP_UI(OPT_FORMS_HEADERS ${OPT_FORMS})
# ENDIF()

# cleanup $build/*.cpp~ on "make clean"
SET_DIRECTORY_PROPERTIES(PROPERTIES
    ADDITIONAL_MAKE_CLEAN_FILES "${CMAKE_CURRENT_SOURCE_DIR}/*~")

=== distribution/osx/bundle/CMakeLists.txt ===
# Generate an application bundle (new-style)
CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/package-binary-bundle.cpack.in ${CMAKE_CURRENT_BINARY_DIR}/package-binary-bundle.cpack)
CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/Info.plist.in ${CMAKE_CURRENT_BINARY_DIR}/Info.plist @ONLY)
ADD_CUSTOM_TARGET(package-binary-bundle
	${CMAKE_CPACK_COMMAND}
	--config ${CMAKE_CURRENT_BINARY_DIR}/package-binary-bundle.cpack
	)

# Upload the binary bundle to SourceForge for use with the FRS
ADD_CUSTOM_TARGET(upload-binary-bundle
	rsync -avP -e ssh ${CMAKE_CURRENT_BINARY_DIR}/httraqt-setup-${HTTRAQT_VERSION}-${CMAKE_SYSTEM_PROCESSOR}.dmg ${HTTRAQT_SOURCEFORGE_USERNAME}@frs.sourceforge.net:uploads/
	)

=== distribution/win32/nsis/CMakeLists.txt ===
# Generate NSIS installer
CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/package-binary-nsis.cpack.in ${CMAKE_CURRENT_BINARY_DIR}/package-binary-nsis.cpack)
ADD_CUSTOM_TARGET(package-binary-nsis
	${CMAKE_CPACK_COMMAND}
	--config ${CMAKE_CURRENT_BINARY_DIR}/package-binary-nsis.cpack
	)

=== debian/changelog ===
httraqt (1.4.11-2) unstable; urgency=medium

  * [06ba9d7] Fix CMake 4 build. (Closes: #1112996)
  * [7ca87f2] chore(debian): Update Standards-Version to 4.7.2

 -- Anton Gladky <gladk@debian.org>  Thu, 09 Oct 2025 09:01:31 +0200

httraqt (1.4.11-1) unstable; urgency=medium

  * [0616b86] New upstream version 1.4.11. (Closes: #1020677)
  * [9bd1e36] Refresh patches.
  * [afc5a94] Update watch file format version to 4.
  * [b48f362] Use secure URI in Homepage field.
  * [bb713de] Update standards version to 4.6.1, no changes needed.
  * [c0b3ad1] Switch to QT6.
  * [3314f70] Drop doc-base file
  * [999eeed] Override false positive lintian error

 -- Anton Gladky <gladk@debian.org>  Tue, 31 Jan 2023 07:50:23 +0100

=== debian/control ===
Source: httraqt
Standards-Version: 4.7.2
Maintainer: Anton Gladky <gladk@debian.org>
Section: web
Priority: optional
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 libhttrack-dev,
 qt6-base-dev,
 qt6-multimedia-dev,
 libssl-dev,
Vcs-Browser: https://salsa.debian.org/debian/httraqt
Vcs-Git: https://salsa.debian.org/debian/httraqt.git
Homepage: https://httraqt.sourceforge.net/
Rules-Requires-Root: no

Package: httraqt
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: program for downloading of internet sites
 Program is intended for loading of Internet pages and/or their contents,
 equipped with flexible system of settings.
 HTTraQt - graphical user interface (GUI) for HTTrack library,
 developed in C++ and based on multiplatform Qt library.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

export BUILD_DATE=$(shell dpkg-parsechangelog -S Date)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

override_dh_installchangelogs:
	dh_installchangelogs README

override_dh_auto_configure:
	dh_auto_configure -- -DBUILD_DATE="$(BUILD_DATE)"

=== debian/watch ===
version=4
https://sf.net/httraqt httraqt-(\d.*)\.(?:tgz|tbz2|txz|tar\.(?:gz|bz2|xz)) debian uupdate
